//package nl.kallestruik.dtweaks.managers
//
//import nl.kallestruik.dlib.MathHelper
//import nl.kallestruik.dtweaks.spacetimepockets.SpaceTimePocketChunkGenerator
//import org.bukkit.*
//import org.bukkit.entity.Player
//import java.util.*
//
//class PocketDimensionManager(
//    private val mathHelper: MathHelper
//) {
//    val pocketDimension: World = WorldCreator.name("space-time-pockets").generator(SpaceTimePocketChunkGenerator()).createWorld()!!
//    private val data = HashMap<UUID, PocketData>()
//    private var lastCreatedPocket = -1
//
//    fun loadData() {
//        //TODO: Load data from data file on disk.
//    }
//
//    fun saveData() {
//        //TODO: Save data to file on disk.
//    }
//
//    fun teleportPlayerIntoPocket(player: Player, pocketOwner: UUID) {
//        var pocketData = data[pocketOwner]
//        if (pocketData == null) pocketData = if (player.uniqueId == pocketOwner) {
//            createPocketForPlayer(player)
//        } else return
//        player.teleport(
//            Location(
//                pocketDimension, (pocketData.startX + 9).toDouble(), 128.0,
//                (pocketData.startZ + 9).toDouble()
//            )
//        )
//    }
//
//    fun createPocketForPlayer(player: Player): PocketData {
//        // Find a spot
//        val point = findNextFree()
//
//        // Load the chunks
//        for (x in 0..2) {
//            for (y in 0..2) {
//                pocketDimension.loadChunk(point.x / 16 + x, point.z / 16 + y)
//            }
//        }
//
//        // Build the box
//        for (x in 0..17) {
//            for (z in 0..17) {
//                for (y in 0..255) {
//                    if (x == 0 || y == 0 || z == 0 || x == 17 || y == 255 || z == 17) {
//                        pocketDimension.getBlockAt(point.x + x, y, point.z + z).type = Material.BLACK_CONCRETE
//                    }
//                }
//            }
//        }
//
//        // Create the spawning platform
//        pocketDimension.getBlockAt(point.x + 8, 127, point.z + 8).type = Material.STONE
//        pocketDimension.getBlockAt(point.x + 8, 127, point.z + 9).type = Material.STONE
//        pocketDimension.getBlockAt(point.x + 9, 127, point.z + 8).type = Material.STONE
//        pocketDimension.getBlockAt(point.x + 9, 127, point.z + 9).type = Material.STONE
//
//        // Unload the chunks
//        for (x in 0..2) {
//            for (y in 0..2) {
//                pocketDimension.unloadChunk(point.x / 16 + x, point.z / 16 + y)
//            }
//        }
//        val pocketData = PocketData(player.uniqueId, point.x, point.z, ArrayList())
//        data[player.uniqueId] = pocketData
//        return pocketData
//    }
//
//    private fun findNextFree(): Point {
//        while (true) {
//            lastCreatedPocket++
//            val toCheck = getXYForIndex(lastCreatedPocket)
//            val chunk = pocketDimension.getChunkAt(
//                Location(
//                    pocketDimension,
//                    toCheck.x.toDouble(), 0.0, toCheck.z.toDouble()
//                )
//            )
//            val corner = chunk.getBlock(mathHelper.chunkAbs(toCheck.x % 16), 0, mathHelper.chunkAbs(toCheck.z % 16))
//            if (corner.type == Material.AIR) {
//                return toCheck
//            }
//        }
//    }
//
//    private fun getXYForIndex(index: Int): Point {
//        // Space the pockets 256 blocks (16 chunks) from each other with each pocket being 16 blocks (and two for walls)
//        // Also subtract 1 from each point so the interior is chunk aligned.
//        val x = (256 + 16) * (index % 1000) - 1
//        val z = (256 + 16) * (index / 1000) - 1
//        return Point(x, z)
//    }
//
//    class PocketData(var owner: UUID, var startX: Int, var startZ: Int, var queuedGateways: ArrayList<GatewayData?>)
//
//    class GatewayData
//
//    class Point(var x: Int, var y: Int, var z: Int) {
//        constructor(x: Int, z: Int) : this(x, 0, z) {}
//    }
//}