package nl.kallestruik.dtweaks

import org.bukkit.Material

enum class BundleVariant(
    val modelDataStart: Int,
    val maxWeight: Int,
    val material: Material?,
) {
    NORMAL(0, 1 * 64, null),
    IRON(100, 2 * 64, Material.IRON_INGOT),
    GOLD(200, 4 * 64, Material.GOLD_INGOT),
    DIAMOND(300, 6 * 64, Material.DIAMOND),
    NETHERITE(400, 8 * 64, Material.NETHERITE_INGOT)
}